> ## Documentation Index
> Fetch the complete documentation index at: https://www.cometchat.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Users

> Users — CometChat documentation.

## Overview

The Users is a [Component](/docs/ui-kit/angular/v4/components-overview#components), showcasing an accessible list of all available users. It provides an integral search functionality, allowing you to locate any specific user swiftly and easily. For each user listed, the widget displays the user's name by default, in conjunction with their avatar when available. Furthermore, it includes a status indicator, visually informing you whether a user is currently online or offline.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/GrDbzzq1LLfv-sgw/images/8467ba94-users_overview_web_screens-78b96ced14cab395635e652cad4848c7.png?fit=max&auto=format&n=GrDbzzq1LLfv-sgw&q=85&s=f3b3fb8b5183779c95fed6bc486f8ad3" width="3600" height="2400" data-path="images/8467ba94-users_overview_web_screens-78b96ced14cab395635e652cad4848c7.png" />
</Frame>

The Users component is composed of the following BaseComponents:

| Components                                        | Description                                                                                                             |
| ------------------------------------------------- | ----------------------------------------------------------------------------------------------------------------------- |
| [CometChatList](/docs/ui-kit/angular/v4/list)          | a reusable container component having title, search box, customisable background and a List View                        |
| [CometChatListItem](/docs/ui-kit/angular/v4/list-item) | a component that renders data obtained from a User object on a Tile having a title, subtitle, leading and trailing view |

***

## Usage

### Integration

The following code snippet illustrates how you can directly incorporate the Users component into your Application.

<Tabs>
  <Tab title="app.module.ts">
    ```ts theme={null}
    import { CUSTOM_ELEMENTS_SCHEMA, NgModule } from "@angular/core";
    import { BrowserModule } from "@angular/platform-browser";
    import { CometChatUsers } from "@cometchat/chat-uikit-angular";
    import { AppComponent } from "./app.component";

    @NgModule({
      imports: [BrowserModule, CometChatUsers],
      declarations: [AppComponent],
      providers: [],
      bootstrap: [AppComponent],
      schemas: [CUSTOM_ELEMENTS_SCHEMA],
    })
    export class AppModule {}
    ```
  </Tab>

  <Tab title="app.component.ts">
    ```ts theme={null}
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      title = 'angular-app';
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-users></cometchat-users>
    </div>
    ```
  </Tab>
</Tabs>

***

### Actions

[Actions](/docs/ui-kit/angular/v4/components-overview#actions) dictate how a component functions. They are divided into two types: Predefined and User-defined. You can override either type, allowing you to tailor the behavior of the component to fit your specific needs.

##### 1. onSelect

The `onSelect` action is activated when you select the done icon while in selection mode. This returns a list of all the users that you have selected.

This action does not come with any predefined behavior. However, you have the flexibility to override this event and tailor it to suit your needs using the following code snippet.

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import { SelectionMode } from '@cometchat/uikit-resources';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      title = 'angular-doc-app';
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      public selectionMode : SelectionMode = SelectionMode.multiple;
      public handleOnSelect = (user: CometChat.User, selected: boolean): void=>{
        console.log("Custom on select action", user, selected);
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-users
        [selectionMode]="selectionMode"
        [onSelect]="handleOnSelect"
      ></cometchat-users>
    </div>
    ```
  </Tab>
</Tabs>

***

##### 2. onItemClick

The `OnItemClick` event is activated when you click on the UserList item. This action does not come with any predefined behavior. However, you have the flexibility to override this event and tailor it to suit your needs using the following code snippet.

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      title = 'angular-app';
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      public handleOnItemClick = (user: CometChat.User) : void =>{
        console.log("your custom on item click action", user);
      };


      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-users [onItemClick]="handleOnItemClick"></cometchat-users>
    </div>
    ```
  </Tab>
</Tabs>

***

##### 3. onEmpty

This action allows you to specify a callback function to be executed when a certain condition, typically the absence of data or content, is met within the component or element.

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      title = 'angular-app';
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      public handleOnEmpty = () =>{
        console.log("your custom on empty action");
      }


      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-users [onEmpty]="handleOnEmpty"></cometchat-users>
    </div>
    ```
  </Tab>
</Tabs>

***

##### 4. onError

This action doesn't change the behavior of the component but rather listens for any errors that occur in the User component.

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      title = 'angular-app';
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      public handleOnError = (error: CometChat.CometChatException) => {
        console.log("your custom on error action", error);
      };

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-users [onError]="handleOnError"></cometchat-users>
    </div>
    ```
  </Tab>
</Tabs>

***

### Filters

**Filters** allow you to customize the data displayed in a list within a Component. You can filter the list based on your specific criteria, allowing for a more customized. Filters can be applied using RequestBuilders of Chat SDK.

##### 1. UserRequestBuilder

The [UserRequestBuilder](/docs/sdk/javascript/retrieve-users) enables you to filter and customize the user list based on available parameters in UserRequestBuilder. This feature allows you to create more specific and targeted queries when fetching users. The following are the parameters available in [UserRequestBuilder](/docs/sdk/javascript/retrieve-users)

| Methods              | Type          | Description                                                                            |
| -------------------- | ------------- | -------------------------------------------------------------------------------------- |
| **setLimit**         | number        | sets the number users that can be fetched in a single request, suitable for pagination |
| **setSearchKeyword** | String        | used for fetching users matching the passed string                                     |
| **hideBlockedUsers** | boolean       | used for fetching all those users who are not blocked by the logged in user            |
| **friendsOnly**      | boolean       | used for fetching only those users in which logged in user is a member                 |
| **setRoles**         | List\<String> | used for fetching users containing the passed tags                                     |
| **setTags**          | List\<String> | used for fetching users containing the passed tags                                     |
| **withTags**         | boolean       | used for fetching users containing tags                                                |
| **setStatus**        | String        | used for fetching users by their status online or offline                              |
| **setUIDs**          | List\<String> | used for fetching users containing the passed users                                    |

**Example**

In the example below, we are applying a filter to the UserList based on Friends.

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      title = 'angular-app';
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      usersRequestBuilder = new CometChat.UsersRequestBuilder().friendsOnly(true).setLimit(5)

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-users
        [usersRequestBuilder]="usersRequestBuilder"
      ></cometchat-users>
    </div>
    ```
  </Tab>
</Tabs>

##### 2. SearchRequestBuilder

The SearchRequestBuilder uses [UserRequestBuilder](/docs/sdk/javascript/retrieve-users) enables you to filter and customize the search list based on available parameters in UserRequestBuilder. This feature allows you to keep uniformity between the displayed UserList and searched UserList.

**Example**

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      title = 'angular-app';
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      searchRequestBuilder = new CometChat.UsersRequestBuilder().setSearchKeyword("**")

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-users
        [searchRequestBuilder]="searchRequestBuilder"
      ></cometchat-users>
    </div>
    ```
  </Tab>
</Tabs>

***

### Events

[Events](/docs/ui-kit/angular/v4/components-overview#events) are emitted by a `Component`. By using event you can extend existing functionality. Being global events, they can be applied in Multiple Locations and are capable of being Added or Removed.

To handle events supported by Users you have to add corresponding listeners by using `CometChatUserEvents`

The `Users` component does not produce any events directly.

***

## Customization

To fit your app's design requirements, you can customize the appearance of the Users component. We provide exposed methods that allow you to modify the experience and behavior according to your specific needs.

### Style

Using **Style** you can **customize** the look and feel of the component in your app, These parameters typically control elements such as the **color**, **size**, **shape**, and **fonts** used within the component.

##### 1. Users Style

You can set the `UsersStyle` to the Users Component to customize the styling.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/KQU96uDrdF-ESW1d/images/317eee3e-users_style-2240b077f86c27ed570972fd72a5827f.png?fit=max&auto=format&n=KQU96uDrdF-ESW1d&q=85&s=90d246803c7c7ca25753f0f4f20e0808" width="1800" height="1200" data-path="images/317eee3e-users_style-2240b077f86c27ed570972fd72a5827f.png" />
</Frame>

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import { UsersStyle } from '@cometchat/uikit-shared';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      title = 'angular-app';
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      usersStyle = new UsersStyle({
        background: "#f7f2ff",
        titleTextColor: "#6414fa",
        searchTextColor: "#940be3",
        separatorColor: "#ffffff",
      });
      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-users [usersStyle]="usersStyle"></cometchat-users>
    </div>
    ```
  </Tab>
</Tabs>

List of properties exposed by UsersStyle

| Property                       | Description                                                                                                      | Code                                   |
| ------------------------------ | ---------------------------------------------------------------------------------------------------------------- | -------------------------------------- |
| **border**                     | Used to set border                                                                                               | `border?: string,`                     |
| **borderRadius**               | Used to set border radius                                                                                        | `borderRadius?: string;`               |
| **background**                 | Used to set background colour                                                                                    | `background?: string;`                 |
| **height**                     | Used to set height                                                                                               | `height?: string;`                     |
| **width**                      | Used to set width                                                                                                | `width?: string;`                      |
| **titleTextFont**              | Used to customise the font of the title in the app bar                                                           | `titleTextFont?: string;`              |
| **titleTextColor**             | Used to customise the color of the title in the app bar                                                          | `titleTextColor?: string;`             |
| **emptyStateTextFont**         | Used to set the font style of the response text shown when fetchig the list of users has returned an empty list  | `emptyStateTextFont?: string;`         |
| **emptyStateTextColor**        | Used to set the color of the response text shown when fetchig the list of users has returned an empty list       | `emptyStateTextColor?: string;`        |
| **errorStateTextFont**         | Used to set the font style of the response text shown in case some error occurs while fetching the list of users | `errorStateTextFont?: string;`         |
| **errorStateTextColor**        | Used to set the font style of the response text shown in case some error occurs while fetching the list of users | `errorStateTextColor?: string;`        |
| **loadingIconTint**            | Used to set the color of the icon shown while the list of users is being fetched                                 | `loadingIconTint?: string;`            |
| **onlineStatusColor**          | Used to set the color of the status indicator shown if a user is online                                          | `onlineStatusColor?: string;`          |
| **separatorColor**             | Used to set the color of the divider separating the group member items                                           | `separatorColor?: string;`             |
| **boxShadow**                  | Sets shadow effects around the element                                                                           | `boxShadow?: string;`                  |
| **searchIconTint**             | Used to set the color of the search icon in the search box                                                       | `searchIconTint?: string;`             |
| **searchBorder**               | Used to set the border of the search box                                                                         | `searchBorder?: string;`               |
| **searchBorderRadius**         | Used to set the border radius of the search box                                                                  | `searchBorderRadius?: string;`         |
| **searchBackground**           | Used to set the background color of the search box                                                               | `searchBackground?: string;`           |
| **searchPlaceholderTextFont**  | Used to set the font of the placeholder text in the search box                                                   | `searchPlaceholderTextFont?: string;`  |
| **searchPlaceholderTextColor** | Used to set the color of the placeholder text in the search box                                                  | `searchPlaceholderTextColor?: string;` |
| **searchTextFont**             | Used to set the font of the text in the search box                                                               | `searchTextFont?: string;`             |
| **searchTextColor**            | Used to set the color of the text in the search box                                                              | `searchTextColor?: string;`            |
| **sectionHeaderTextFont**      | Used to customise the font of the section header text.                                                           | `sectionHeaderTextFont?: string;`      |
| **sectionHeaderTextColor**     | Used to customise the color of the section header text.                                                          | `sectionHeaderTextColor?: string;`     |

##### 2. Avatar Style

To apply customized styles to the `Avatar` component in the Users Component, you can use the following code snippet. For further insights on `Avatar` Styles [refer](/docs/ui-kit/angular/v4/avatar#avatar-style)

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit, AvatarStyle } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      title = 'angular-app';
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      avatarStyle = new AvatarStyle({
        backgroundColor: "#cdc2ff",
        border: "2px solid #6745ff",
        borderRadius: "10px",
        outerViewBorderColor: "#ca45ff",
        outerViewBorderRadius: "5px",
        nameTextColor: "#4554ff"
      });
      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-users [avatarStyle]="avatarStyle"></cometchat-users>
    </div>
    ```
  </Tab>
</Tabs>

##### 3. StatusIndicator Style

To apply customized styles to the Status Indicator component in the Users Component, You can use the following code snippet. For further insights on Status Indicator Styles [refer](/docs/ui-kit/angular/v4/status-indicator)

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      title = 'angular-app';
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      statusIndicatorStyle: any = ({
        height: '20px',
        width: '20px',
        backgroundColor: 'red'
      });
      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-users
        [statusIndicatorStyle]="statusIndicatorStyle"
      ></cometchat-users>
    </div>
    ```
  </Tab>
</Tabs>

##### 4. LisItem Style

To apply customized styles to the `List Item` component in the `Users` Component, you can use the following code snippet. For further insights on `List Item` Styles [refer](/docs/ui-kit/angular/v4/list-item)

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import {  CometChatThemeService, CometChatUIKit, ListItemStyle } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      title = 'angular-app';
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      listItemStyle: ListItemStyle = new ListItemStyle({
        background: "transparent",
        padding: "5px",
        border: "1px solid #e9b8f5",
        titleColor: "#8830f2",
        borderRadius: "20px",
        width: "100% !important"
      });
      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-users [listItemStyle]="listItemStyle"></cometchat-users>
    </div>
    ```
  </Tab>
</Tabs>

***

### Functionality

These are a set of small functional customizations that allow you to fine-tune the overall experience of the component. With these, you can change text, set custom icons, and toggle the visibility of UI elements.

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import { CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import { TitleAlignment } from '@cometchat/uikit-resources';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      title = 'your custom title';
      titleAlignment = TitleAlignment.center;
      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }

      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-users
        [title]="title"
        [showSectionHeader]="true"
        [titleAlignment]="titleAlignment"
      ></cometchat-users>
    </div>
    ```
  </Tab>
</Tabs>

Default:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/vk8kXY4T6hhH4l00/images/6bd3be30-users_functionality_default_web_screens-06be4ffd818857e8877121f8f24d63fa.png?fit=max&auto=format&n=vk8kXY4T6hhH4l00&q=85&s=8130efc077985235964eb990ebbf632d" width="3600" height="2400" data-path="images/6bd3be30-users_functionality_default_web_screens-06be4ffd818857e8877121f8f24d63fa.png" />
</Frame>

Custom:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/Relz_yItqW5RHUsU/images/517733c0-users_functionality_custom_web_screens-89c18bb5f32c29c06539887abef9d188.png?fit=max&auto=format&n=Relz_yItqW5RHUsU&q=85&s=00b2c783d672d358a0bbc6920d2f5c87" width="3600" height="2400" data-path="images/517733c0-users_functionality_custom_web_screens-89c18bb5f32c29c06539887abef9d188.png" />
</Frame>

Below is a list of customizations along with corresponding code snippets

| Property                                                            | Description                                                                                                                                             | Code                                              |
| ------------------------------------------------------------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------- | ------------------------------------------------- |
| **title** <Tooltip tip="Not available">🛑</Tooltip>                 | Used to set title in the app bar                                                                                                                        | `[title]="title"`                                 |
| **searchPlaceholderText** <Tooltip tip="Not available">🛑</Tooltip> | Used to set search placeholder text                                                                                                                     | `[searchPlaceholderText ="searchPlaceholderText"` |
| **searchIconURL**                                                   | Used to set search Icon in the search field                                                                                                             | `[searchIconURL]="searchIconURL"`                 |
| **loadingIconURL**                                                  | Used to set loading Icon                                                                                                                                | `[loadingIconURL]="loadingIconURL"`               |
| **closeButtonIconURL** <Tooltip tip="Not available">🛑</Tooltip>    | Used to set the close button Icon                                                                                                                       | `[closeButtonIconURL]="closeButtonIconURL"`       |
| **hideSearch**                                                      | Used to toggle visibility for search box                                                                                                                | `[hideSearch]="true"`                             |
| **hideError**                                                       | Used to hide error on fetching users                                                                                                                    | `[hideError]="true"`                              |
| **hideSeparator**                                                   | Used to hide the divider separating the user items                                                                                                      | `[hideSeparator]="true"`                          |
| **disableUsersPresence**                                            | Used to control visibility of user indicator shown if user is online                                                                                    | `[disableUsersPresence]="true"`                   |
| **disableLoadingState** <Tooltip tip="Not available">🛑</Tooltip>   | Used to control visibility of loading state                                                                                                             | `[disableLoadingState]="true"`                    |
| **emptyStateText** <Tooltip tip="Not available">🛑</Tooltip>        | Used to set a custom text response when fetching the users has returned an empty list                                                                   | `[emptyStateText]="emptyStateText"`               |
| **errorStateText** <Tooltip tip="Not available">🛑</Tooltip>        | Used to set a custom text response when some error occurs on fetching the list of users                                                                 | `[errorStateText]="errorStateText"`               |
| **activeUser** <Tooltip tip="Not available">🛑</Tooltip>            | Used to set the active user                                                                                                                             | `[activeUser]="userObject"`                       |
| **userPresencePlacement** <Tooltip tip="Not available">🛑</Tooltip> | The `userPresencePlacement` property determines the placement of user presence indicators, allowing options for either "right" or "bottom" positioning. | `[userPresencePlacement]="userPresencePlacement"` |
| **searchKeyword** <Tooltip tip="Not available">🛑</Tooltip>         | The `searchKeyword` property facilitates searching/filtering based on the provided keyword, enhancing the functionality of the component.               | `[searchKeyword]="searchKeyword"`                 |

***

### Advance

For advanced-level customization, you can set custom views to the component. This lets you tailor each aspect of the component to fit your exact needs and application aesthetics. You can create and define your views, layouts, and UI elements and then incorporate those into the component.

***

#### ListItemView

With this property, you can assign a custom ListItem to the Users Component.

**Example**

Default:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/0Cdnhz6eU6kdn5Ms/images/b25ebf2e-users_listItemView_default_web_screens-817ff24a42eb96280eb523fff7cbc20e.png?fit=max&auto=format&n=0Cdnhz6eU6kdn5Ms&q=85&s=b8d3d5a09ad266342a779ec9dec4a457" width="3600" height="2400" data-path="images/b25ebf2e-users_listItemView_default_web_screens-817ff24a42eb96280eb523fff7cbc20e.png" />
</Frame>

Custom:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/GrDbzzq1LLfv-sgw/images/873ada0d-users_listItemView_custom_web_screens-2440a52eeee3fd2c8e108e2af35fce00.png?fit=max&auto=format&n=GrDbzzq1LLfv-sgw&q=85&s=a1a6a378d31843faba67cf8b67fe001d" width="3600" height="2400" data-path="images/873ada0d-users_listItemView_custom_web_screens-2440a52eeee3fd2c8e108e2af35fce00.png" />
</Frame>

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import { CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }
      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-users [listItemView]="listItemViewTemplateUser"></cometchat-users>
    </div>

    <ng-template #listItemViewTemplateUser let-user>
      <div
        [ngStyle]="{
          display: 'flex',
          alignItems: 'left',
          padding: '10px',
          border: '2px solid #e9baff',
          borderRadius: '20px',
          background: '#ffffff'
        }"
      >
        <cometchat-avatar
          [image]="user.getAvatar()"
          [name]="user.getName()"
        ></cometchat-avatar>
        <div [ngStyle]="{ display: 'flex', paddingLeft: '10px' }">
          <div
            [ngStyle]="{
              fontWeight: 'bold',
              color: '#937aff',
              fontSize: '14px',
              marginTop: '5px'
            }"
          >
            {{ user.getName() }}
            <div
              [ngStyle]="{
                color: '#cfc4ff',
                fontSize: '10px',
                textAlign: 'left'
              }"
            >
              {{ user.getStatus() }}
            </div>
          </div>
        </div>
      </div>
    </ng-template>
    ```
  </Tab>
</Tabs>

***

#### SubtitleView

You can customize the subtitle view for each user item to meet your requirements

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/Mh-tK73gC5erLrBQ/images/f57d6d9e-users_subtitleView_custom_web_screens-7aa1af4f579f64849a4eead5977a6c26.png?fit=max&auto=format&n=Mh-tK73gC5erLrBQ&q=85&s=aee4f355c2d50a9da3647a8e4a216ae7" width="3600" height="2400" data-path="images/f57d6d9e-users_subtitleView_custom_web_screens-7aa1af4f579f64849a4eead5977a6c26.png" />
</Frame>

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import { CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }
      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-users [subtitleView]="subtitleTemplateUser"></cometchat-users>
    </div>
    <ng-template #subtitleTemplateUser let-user>
      <div
        [ngStyle]="{
        display: 'flex',
        alignItems: 'left',
        padding: '10px',
        fontSize: '10px'
      }"
      >
        <div [ngStyle]="{ color: 'gray' }">Your Custom Subtitle View</div>
      </div>
    </ng-template>
    ```
  </Tab>
</Tabs>

***

#### LoadingStateView

You can set a custom loader view using `loadingStateView` to match the loading view of your app.

Default:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/L67V-UjCgqzL1qxp/images/72c9976c-users_loadingview_default_web_screens-9518b5dcdcfce21bcd6f618ec10788c3.png?fit=max&auto=format&n=L67V-UjCgqzL1qxp&q=85&s=872460652491c375331eb2142347fa5d" width="3600" height="2400" data-path="images/72c9976c-users_loadingview_default_web_screens-9518b5dcdcfce21bcd6f618ec10788c3.png" />
</Frame>

Custom:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/-ESEkh1kVWNrvtT0/images/66dc0eb6-users_loadingview_custom_web_screens-69f5b50780f182b1e82ed4f2b7e631ae.png?fit=max&auto=format&n=-ESEkh1kVWNrvtT0&q=85&s=f4a3f6d4281b4143e74977a8297eac10" width="3600" height="2400" data-path="images/66dc0eb6-users_loadingview_custom_web_screens-69f5b50780f182b1e82ed4f2b7e631ae.png" />
</Frame>

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import { CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }
      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-users [loadingStateView]="loadingStateView"></cometchat-users>
    </div>
    <ng-template #loadingStateView>
      <cometchat-loader
        iconURL="icon"
        loaderStyle="getLoaderStyle()"
      ></cometchat-loader>
    </ng-template>
    ```
  </Tab>
</Tabs>

***

#### EmptyStateView

You can set a custom `EmptyStateView` using `emptyStateView` to match the empty view of your app.

Default:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/_jsRdrzYcNj1bcHI/images/423fd200-users_emptyview_default_web_screens-d714327a05408bf9f8dfef94ba70a16e.png?fit=max&auto=format&n=_jsRdrzYcNj1bcHI&q=85&s=7072c2741147ee5f96694cb72078d5cc" width="3600" height="2400" data-path="images/423fd200-users_emptyview_default_web_screens-d714327a05408bf9f8dfef94ba70a16e.png" />
</Frame>

Custom:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/bUk-WwSNpBXF92Yc/images/d9c523aa-users_emptyview_custom_web_screens-d0df4badd0d163b2dc33db158a2e491b.png?fit=max&auto=format&n=bUk-WwSNpBXF92Yc&q=85&s=eb736d544b2f22e61813813f899fe6e6" width="3600" height="2400" data-path="images/d9c523aa-users_emptyview_custom_web_screens-d0df4badd0d163b2dc33db158a2e491b.png" />
</Frame>

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import { CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }
      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-users [emptyStateView]="emptyStateView"></cometchat-users>
    </div>
    <ng-template #emptyStateView>
      <div>Your Custom Empty State</div>
    </ng-template>
    ```
  </Tab>
</Tabs>

***

#### ErrorStateView

You can set a custom `ErrorStateView` using `errorStateView` to match the empty view of your app.

Default:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/RxKy5RgybeX-8GbH/images/1be29124-users_errorview_default_web_screens-66729848c113467ed7d715c5aecd8288.png?fit=max&auto=format&n=RxKy5RgybeX-8GbH&q=85&s=764d221acc87b2af7000a2fbcf012463" width="3600" height="2400" data-path="images/1be29124-users_errorview_default_web_screens-66729848c113467ed7d715c5aecd8288.png" />
</Frame>

Custom:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/bUk-WwSNpBXF92Yc/images/daa8bc75-users_errorview_custom_web_screens-9e18c9a19c73b7b0d443fc0da231e66e.png?fit=max&auto=format&n=bUk-WwSNpBXF92Yc&q=85&s=4ebf7802334db77545d73eaf7268edaf" width="3600" height="2400" data-path="images/daa8bc75-users_errorview_custom_web_screens-9e18c9a19c73b7b0d443fc0da231e66e.png" />
</Frame>

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import { CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }
      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-users [errorStateView]="errorStateView"></cometchat-users>
    </div>
    <ng-template #errorStateView>
      <div style="height: 100vh; width: 100vw">
        <img
          src="img"
          alt="error icon"
          style="height:100px; width: 100px; justify-content: center"
        />
      </div>
    </ng-template>
    ```
  </Tab>
</Tabs>

***

#### Menus

You can set the Custom Menu view to add more options to the Users component.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/Mh-tK73gC5erLrBQ/images/f7387500-users_menus_web_screens-4265d9c0530f9c360c24ccf98c75533f.png?fit=max&auto=format&n=Mh-tK73gC5erLrBQ&q=85&s=40ad7dc2dd61a7dfaaf8e4d27fd9e28b" width="3600" height="2400" data-path="images/f7387500-users_menus_web_screens-4265d9c0530f9c360c24ccf98c75533f.png" />
</Frame>

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import { CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }
      handleReload(): void {
        window.location.reload();
      }

      getButtonStyle() {
        return {
          height: '20px',
          width: '20px',
          border: 'none',
          borderRadius: '0',
          background: 'transparent'
        };
      }
      getButtonIconStyle() {
        return {
          color: '#7E57C2'
        };
      }
      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-users [menu]="menuTemplate"></cometchat-users>
    </div>
    <ng-template #menuTemplate>
      <div style="margin-right: 20px;">
        <button [ngStyle]="getButtonStyle()" (click)="handleReload()">
          <img src="img" [ngStyle]="getButtonIconStyle()" alt="Reload Icon" />
        </button>
      </div>
    </ng-template>
    ```
  </Tab>
</Tabs>

***

#### Options

You can set the Custom options to the Users component.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/THlknidvlbNx5AzI/images/a923d4a0-users_options_web_screens-bb164b0745ab580bd787ef4a1a9c1b95.png?fit=max&auto=format&n=THlknidvlbNx5AzI&q=85&s=e0ac89b709feca7d14f38c7658b23423" width="3600" height="2400" data-path="images/a923d4a0-users_options_web_screens-bb164b0745ab580bd787ef4a1a9c1b95.png" />
</Frame>

<Tabs>
  <Tab title="app.component.ts">
    ```ts theme={null}
    import { CometChat } from '@cometchat/chat-sdk-javascript';
    import { Component, OnInit } from '@angular/core';
    import { CometChatThemeService, CometChatUIKit } from '@cometchat/chat-uikit-angular';
    import { CometChatOption } from '@cometchat/uikit-resources';
    import "@cometchat/uikit-elements";

    @Component({
      selector: 'app-root',
      templateUrl: './app.component.html',
      styleUrls: ['./app.component.css']
    })
    export class AppComponent {

      constructor(private themeService:CometChatThemeService) {
        themeService.theme.palette.setMode("light")
        themeService.theme.palette.setPrimary({ light: "#6851D6", dark: "#6851D6" })
      }
      getOptions = (member: CometChat.User) => {
        const customOptions = [
          new CometChatOption({
            id: "1",
            title: "Title",
            iconURL: "icon",
            backgroundColor: "red",
            onClick: () => {
              console.log("Custom option clicked for user:", memeber);
            },
          }),
        ];
        return customOptions;
      };
      onLogin(UID?: any) {
        CometChatUIKit.login({ uid: UID }).then(
          (user) => {
            setTimeout(() => {
              window.location.reload();
            }, 1000);
          },
          (error) => {
            console.log("Login failed with exception:", { error });
          }
        );
      }
    }
    ```
  </Tab>

  <Tab title="app.component.html">
    ```html theme={null}
    <div class="fullwidth">
      <cometchat-users [options]="getOptions"></cometchat-users>
    </div>
    ```
  </Tab>
</Tabs>


> ## Documentation Index
> Fetch the complete documentation index at: https://www.cometchat.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Users

> Users — CometChat documentation.

## Overview

The Users is a [Component](/ui-kit/react/v4/components-overview#components), showcasing an accessible list of all available users. It provides an integral search functionality, allowing you to locate any specific user swiftly and easily. For each user listed, the widget displays the user's name by default, in conjunction with their avatar when available. Furthermore, it includes a status indicator, visually informing you whether a user is currently online or offline.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/GrDbzzq1LLfv-sgw/images/8467ba94-users_overview_web_screens-78b96ced14cab395635e652cad4848c7.png?fit=max&auto=format&n=GrDbzzq1LLfv-sgw&q=85&s=f3b3fb8b5183779c95fed6bc486f8ad3" width="3600" height="2400" data-path="images/8467ba94-users_overview_web_screens-78b96ced14cab395635e652cad4848c7.png" />
</Frame>

The Users component is composed of the following BaseComponents:

| Components                                      | Description                                                                                                             |
| ----------------------------------------------- | ----------------------------------------------------------------------------------------------------------------------- |
| [CometChatList](/ui-kit/react/v4/list)          | a reusable container component having title, search box, customisable background and a List View                        |
| [CometChatListItem](/ui-kit/react/v4/list-item) | a component that renders data obtained from a User object on a Tile having a title, subtitle, leading and trailing view |

***

## Usage

### Integration

The following code snippet illustrates how you can directly incorporate the Users component into your Application.

<Tabs>
  <Tab title="UsersDemo.tsx">
    ```typescript theme={null}
    import { CometChatUsers } from "@cometchat/chat-uikit-react";

    function UsersDemo() {
      return <CometChatUsers />;
    }

    export default UsersDemo;
    ```
  </Tab>

  <Tab title="App.tsx">
    ```typescript theme={null}
    import { UsersDemo } from "./UsersDemo";

    export default function App() {
      return (
        <div className="App">
          <UsersDemo />
        </div>
      );
    }
    ```
  </Tab>
</Tabs>

### Actions

[Actions](/ui-kit/react/v4/components-overview#actions) dictate how a component functions. They are divided into two types: Predefined and User-defined. You can override either type, allowing you to tailor the behavior of the component to fit your specific needs.

#### 1. onSelect

The `onSelect` action is activated when you select the done icon while in selection mode. This returns a list of all the users that you have selected.

This action does not come with any predefined behavior. However, you have the flexibility to override this event and tailor it to suit your needs using the following code snippet.

<Tabs>
  <Tab title="TypeScript">
    UsersDemo.tsx

    ```typescript theme={null}
    import { CometChatUsers, SelectionMode } from "@cometchat/chat-uikit-react";

    function UsersDemo() {
      function handleOnSelect(users: CometChat.User, selected: boolean): void {
        console.log(users);
        //your custom onSelect actions
      }

      return (
        <CometChatUsers
          selectionMode={SelectionMode.multiple}
          onSelect={handleOnSelect}
        />
      );
    }

    export default UsersDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    UsersDemo.jsx

    ```javascript theme={null}
    import { CometChatUsers, SelectionMode } from "@cometchat/chat-uikit-react";

    function UsersDemo() {
      function handleOnSelect(users, selected) {
        console.log(users);
        //your custom onSelect actions
      }

      return (
        <CometChatUsers
          selectionMode={SelectionMode.multiple}
          onSelect={handleOnSelect}
        />
      );
    }

    export default UsersDemo;
    ```
  </Tab>
</Tabs>

#### 2. onItemClick

The `OnItemClick` event is activated when you click on the UserList item. This action does not come with any predefined behavior. However, you have the flexibility to override this event and tailor it to suit your needs using the following code snippet.

<Tabs>
  <Tab title="TypeScript">
    UsersDemo.tsx

    ```typescript theme={null}
    import { CometChatUsers } from "@cometchat/chat-uikit-react";

    function UsersDemo() {
      function handleOnItemClick(user: CometChat.User): void {
        console.log(user, "your custom on item click action");
      }
      return <CometChatUsers onItemClick={handleOnItemClick} />;
    }

    export default UsersDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    UsersDemo.jsx

    ```javascript theme={null}
    import { CometChatUsers } from "@cometchat/chat-uikit-react";

    function UsersDemo() {
      function handleOnItemClick(user) {
        console.log(user, "your custom on item click action");
      }

      return <CometChatUsers onItemClick={handleOnItemClick} />;
    }

    export default UsersDemo;
    ```
  </Tab>
</Tabs>

#### 3. onEmpty

This action allows you to specify a callback function to be executed when a certain condition, typically the absence of data or content, is met within the component or element.

<Tabs>
  <Tab title="TypeScript">
    UsersDemo.tsx

    ```typescript theme={null}
    import { CometChatUsers } from "@cometchat/chat-uikit-react";

    function UsersDemo() {
      function handleOnEmpty(): void {
        console.log("your custom on Empty action");
      }
      return <CometChatUsers onEmpty={handleOnEmpty} />;
    }

    export default UsersDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    UsersDemo.jsx

    ```javascript theme={null}
    import { CometChatUsers } from "@cometchat/chat-uikit-react";

    function UsersDemo() {
      function handleOnEmpty() {
        console.log("your custom on Empty action");
      }

      return <CometChatUsers onEmpty={handleOnEmpty} />;
    }

    export default UsersDemo;
    ```
  </Tab>
</Tabs>

#### 4. onError

This action doesn't change the behavior of the component but rather listens for any errors that occur in the User component.

<Tabs>
  <Tab title="TypeScript">
    UsersDemo.tsx

    ```typescript theme={null}
    import { CometChatUsers } from "@cometchat/chat-uikit-react";

    function UsersDemo() {
      const handleOnError = (error: CometChat.CometChatException) => {
        console.log("Your custom on error actions");
      };
      return <CometChatUsers onError={handleOnError} />;
    }

    export default UsersDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    UsersDemo.jsx

    ```javascript theme={null}
    import { CometChatUsers } from "@cometchat/chat-uikit-react";

    function UsersDemo() {
      const handleOnError = (error) => {
        console.log("Your custom on error actions");
      };

      return <CometChatUsers onError={handleOnError} />;
    }

    export default UsersDemo;
    ```
  </Tab>
</Tabs>

### Filters

**Filters** allow you to customize the data displayed in a list within a Component. You can filter the list based on your specific criteria, allowing for a more customized. Filters can be applied using RequestBuilders of Chat SDK.

#### 1. UserRequestBuilder

The [UserRequestBuilder](/sdk/javascript/retrieve-users) enables you to filter and customize the user list based on available parameters in UserRequestBuilder. This feature allows you to create more specific and targeted queries when fetching users. The following are the parameters available in [UserRequestBuilder](/sdk/javascript/retrieve-users)

| Methods              | Type          | Description                                                                            |
| -------------------- | ------------- | -------------------------------------------------------------------------------------- |
| **setLimit**         | number        | sets the number users that can be fetched in a single request, suitable for pagination |
| **setSearchKeyword** | String        | used for fetching users matching the passed string                                     |
| **hideBlockedUsers** | boolean       | used for fetching all those users who are not blocked by the logged in user            |
| **friendsOnly**      | boolean       | used for fetching only those users in which logged in user is a member                 |
| **setRoles**         | List\<String> | used for fetching users containing the passed tags                                     |
| **setTags**          | List\<String> | used for fetching users containing the passed tags                                     |
| **withTags**         | boolean       | used for fetching users containing tags                                                |
| **setStatus**        | String        | used for fetching users by their status online or offline                              |
| **setUIDs**          | List\<String> | used for fetching users containing the passed users                                    |

**Example**

In the example below, we are applying a filter to the UserList based on Friends.

<Tabs>
  <Tab title="TypeScript">
    UsersDemo.tsx

    ```typescript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatUsers } from "@cometchat/chat-uikit-react";

    function UsersDemo() {
      return (
        <CometChatUsers
          usersRequestBuilder={new CometChat.UsersRequestBuilder()
            .friendsOnly(true)
            .setLimit(2)}
        />
      );
    }

    export default UsersDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    UsersDemo.jsx

    ```javascript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatUsers } from "@cometchat/chat-uikit-react";

    function UsersDemo() {
      return (
        <CometChatUsers
          usersRequestBuilder={new CometChat.UsersRequestBuilder()
            .friendsOnly(true)
            .setLimit(2)}
        />
      );
    }

    export default UsersDemo;
    ```
  </Tab>
</Tabs>

#### 2. SearchRequestBuilder

The SearchRequestBuilder uses [UserRequestBuilder](/sdk/javascript/retrieve-users) enables you to filter and customize the search list based on available parameters in UserRequestBuilder. This feature allows you to keep uniformity between the displayed UserList and searched UserList.

**Example**

<Tabs>
  <Tab title="TypeScript">
    UsersDemo.tsx

    ```typescript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatUsers } from "@cometchat/chat-uikit-react";

    function UsersDemo() {
      return (
        <CometChatUsers
          searchRequestBuilder={new CometChat.UsersRequestBuilder().setSearchKeyword(
            "**"
          )}
        />
      );
    }

    export default UsersDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    UsersDemo.jsx

    ```javascript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatUsers } from "@cometchat/chat-uikit-react";

    function UsersDemo() {
      return (
        <CometChatUsers
          searchRequestBuilder={new CometChat.UsersRequestBuilder().setSearchKeyword(
            "**"
          )}
        />
      );
    }

    export default UsersDemo;
    ```
  </Tab>
</Tabs>

***

### Events

[Events](/ui-kit/react/v4/components-overview#events) are emitted by a `Component`. By using event you can extend existing functionality. Being global events, they can be applied in Multiple Locations and are capable of being Added or Removed.

To handle events supported by Users you have to add corresponding listeners by using `CometChatUserEvents`

The `Users` component does not produce any events directly.

***

## Customization

To fit your app's design requirements, you can customize the appearance of the Users component. We provide exposed methods that allow you to modify the experience and behavior according to your specific needs.

### Style

Using **Style** you can **customize** the look and feel of the component in your app, These parameters typically control elements such as the **color**, **size**, **shape**, and **fonts** used within the component.

#### 1. Users Style

You can set the `UsersStyle` to the Users Component to customize the styling.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/KQU96uDrdF-ESW1d/images/317eee3e-users_style-2240b077f86c27ed570972fd72a5827f.png?fit=max&auto=format&n=KQU96uDrdF-ESW1d&q=85&s=90d246803c7c7ca25753f0f4f20e0808" width="1800" height="1200" data-path="images/317eee3e-users_style-2240b077f86c27ed570972fd72a5827f.png" />
</Frame>

<Tabs>
  <Tab title="TypeScript">
    UsersDemo.tsx

    ```typescript theme={null}
    import { CometChatUsers, UsersStyle } from "@cometchat/chat-uikit-react";

    function UsersDemo() {
      const usersStyle = new UsersStyle({
        background: "#f7f2ff",
        titleTextColor: "#6414fa",
        searchTextColor: "#940be3",
        separatorColor: "#ffffff",
      });
      return <CometChatUsers usersStyle={usersStyle} />;
    }

    export default UsersDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    UsersDemo.jsx

    ```javascript theme={null}
    import { CometChatUsers, UsersStyle } from "@cometchat/chat-uikit-react";

    function UsersDemo() {
      const usersStyle = new UsersStyle({
        background: "#f7f2ff",
        titleTextColor: "#6414fa",
        searchTextColor: "#940be3",
        separatorColor: "#ffffff",
      });

      return <CometChatUsers usersStyle={usersStyle} />;
    }

    export default UsersDemo;
    ```
  </Tab>
</Tabs>

List of properties exposed by UsersStyle

| Property                       | Description                                                                                                      | Code                                   |
| ------------------------------ | ---------------------------------------------------------------------------------------------------------------- | -------------------------------------- |
| **border**                     | Used to set border                                                                                               | `border?: string,`                     |
| **borderRadius**               | Used to set border radius                                                                                        | `borderRadius?: string;`               |
| **background**                 | Used to set background colour                                                                                    | `background?: string;`                 |
| **height**                     | Used to set height                                                                                               | `height?: string;`                     |
| **width**                      | Used to set width                                                                                                | `width?: string;`                      |
| **titleTextFont**              | Used to customise the font of the title in the app bar                                                           | `titleTextFont?: string;`              |
| **titleTextColor**             | Used to customise the color of the title in the app bar                                                          | `titleTextColor?: string;`             |
| **emptyStateTextFont**         | Used to set the font style of the response text shown when fetchig the list of users has returned an empty list  | `emptyStateTextFont?: string;`         |
| **emptyStateTextColor**        | Used to set the color of the response text shown when fetchig the list of users has returned an empty list       | `emptyStateTextColor?: string;`        |
| **errorStateTextFont**         | Used to set the font style of the response text shown in case some error occurs while fetching the list of users | `errorStateTextFont?: string;`         |
| **errorStateTextColor**        | Used to set the font style of the response text shown in case some error occurs while fetching the list of users | `errorStateTextColor?: string;`        |
| **loadingIconTint**            | Used to set the color of the icon shown while the list of users is being fetched                                 | `loadingIconTint?: string;`            |
| **onlineStatusColor**          | Used to set the color of the status indicator shown if a user is online                                          | `onlineStatusColor?: string;`          |
| **separatorColor**             | Used to set the color of the divider separating the group member items                                           | `separatorColor?: string;`             |
| **boxShadow**                  | Sets shadow effects around the element                                                                           | `boxShadow?: string;`                  |
| **searchIconTint**             | Used to set the color of the search icon in the search box                                                       | `searchIconTint?: string;`             |
| **searchBorder**               | Used to set the border of the search box                                                                         | `searchBorder?: string;`               |
| **searchBorderRadius**         | Used to set the border radius of the search box                                                                  | `searchBorderRadius?: string;`         |
| **searchBackground**           | Used to set the background color of the search box                                                               | `searchBackground?: string;`           |
| **searchPlaceholderTextFont**  | Used to set the font of the placeholder text in the search box                                                   | `searchPlaceholderTextFont?: string;`  |
| **searchPlaceholderTextColor** | Used to set the color of the placeholder text in the search box                                                  | `searchPlaceholderTextColor?: string;` |
| **searchTextFont**             | Used to set the font of the text in the search box                                                               | `searchTextFont?: string;`             |
| **searchTextColor**            | Used to set the color of the text in the search box                                                              | `searchTextColor?: string;`            |
| **sectionHeaderTextFont**      | Used to customise the font of the section header text.                                                           | `sectionHeaderTextFont?: string;`      |
| **sectionHeaderTextColor**     | Used to customise the color of the section header text.                                                          | `sectionHeaderTextColor?: string;`     |

#### 2. Avatar Style

To apply customized styles to the `Avatar` component in the Users Component, you can use the following code snippet. For further insights on `Avatar` Styles [refer](/ui-kit/react/v4/avatar#avatar-style)

<Tabs>
  <Tab title="TypeScript">
    UsersDemo.tsx

    ```typescript theme={null}
    import { CometChatUsers, AvatarStyle } from "@cometchat/chat-uikit-react";

    function UsersDemo() {
      const avatarStyle = new AvatarStyle({
        backgroundColor: "#cdc2ff",
        border: "2px solid #6745ff",
        borderRadius: "10px",
        outerViewBorderColor: "#ca45ff",
        outerViewBorderRadius: "5px",
        nameTextColor: "#4554ff",
      });
      return <CometChatUsers avatarStyle={avatarStyle} />;
    }

    export default UsersDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    UsersDemo.jsx

    ```javascript theme={null}
    import { CometChatUsers, AvatarStyle } from "@cometchat/chat-uikit-react";

    function UsersDemo() {
      const avatarStyle = new AvatarStyle({
        backgroundColor: "#cdc2ff",
        border: "2px solid #6745ff",
        borderRadius: "10px",
        outerViewBorderColor: "#ca45ff",
        outerViewBorderRadius: "5px",
        nameTextColor: "#4554ff",
      });

      return <CometChatUsers avatarStyle={avatarStyle} />;
    }

    export default UsersDemo;
    ```
  </Tab>
</Tabs>

#### 3. StatusIndicator Style

To apply customized styles to the Status Indicator component in the Users Component, You can use the following code snippet. For further insights on Status Indicator Styles [refer](/ui-kit/react/v4/status-indicator)

<Tabs>
  <Tab title="TypeScript">
    UsersDemo.tsx

    ```typescript theme={null}
    import { CometChatUsers } from "@cometchat/chat-uikit-react";

    function UsersDemo() {
      const statusIndicatorStyle = {
        background: "#db35de",
        height: "10px",
        width: "10px",
      };
      return <CometChatUsers statusIndicatorStyle={statusIndicatorStyle} />;
    }

    export default UsersDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    UsersDemo.jsx

    ```javascript theme={null}
    import { CometChatUsers } from "@cometchat/chat-uikit-react";

    function UsersDemo() {
      const statusIndicatorStyle = {
        background: "#db35de",
        height: "10px",
        width: "10px",
      };
      return <CometChatUsers statusIndicatorStyle={statusIndicatorStyle} />;
    }

    export default UsersDemo;
    ```
  </Tab>
</Tabs>

#### 4. LisItem Style

To apply customized styles to the `ListItemStyle` component in the `Users` Component, you can use the following code snippet. For further insights on `ListItemStyle` Styles [refer](/ui-kit/react/v4/list-item)

<Tabs>
  <Tab title="TypeScript">
    UsersDemo.tsx

    ```typescript theme={null}
    import { CometChatUsers, ListItemStyle } from "@cometchat/chat-uikit-react";

    function UsersDemo() {
      const listItemStyle = new ListItemStyle({
        width: "100%",
        height: "100%",
        border: "2px solid red",
      });
      return <CometChatUsers listItemStyle={listItemStyle} />;
    }

    export default UsersDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    UsersDemo.jsx

    ```javascript theme={null}
    import { CometChatUsers, ListItemStyle } from "@cometchat/chat-uikit-react";

    function UsersDemo() {
      const listItemStyle = new ListItemStyle({
        width: "100%",
        height: "100%",
        border: "2px solid red",
      });
      return <CometChatUsers listItemStyle={listItemStyle} />;
    }

    export default UsersDemo;
    ```
  </Tab>
</Tabs>

***

### Functionality

These are a set of small functional customizations that allow you to fine-tune the overall experience of the component. With these, you can change text, set custom icons, and toggle the visibility of UI elements.

<Tabs>
  <Tab title="TypeScript">
    UsersDemo.tsx

    ```typescript theme={null}
    import { CometChatUsers, TitleAlignment } from "@cometchat/chat-uikit-react";

    function UsersDemo() {
      return (
        <CometChatUsers
          title="Your Custom Title"
          showSectionHeader={true}
          tileAlignment={TitleAlignment.center}
        />
      );
    }

    export default UsersDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    UsersDemo.jsx

    ```javascript theme={null}
    import { CometChatUsers, TitleAlignment } from "@cometchat/chat-uikit-react";

    function UsersDemo() {
      return (
        <CometChatUsers
          title="Your Custom Title"
          showSectionHeader={true}
          tileAlignment={TitleAlignment.center}
        />
      );
    }

    export default UsersDemo;
    ```
  </Tab>
</Tabs>

Default:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/vk8kXY4T6hhH4l00/images/6bd3be30-users_functionality_default_web_screens-06be4ffd818857e8877121f8f24d63fa.png?fit=max&auto=format&n=vk8kXY4T6hhH4l00&q=85&s=8130efc077985235964eb990ebbf632d" width="3600" height="2400" data-path="images/6bd3be30-users_functionality_default_web_screens-06be4ffd818857e8877121f8f24d63fa.png" />
</Frame>

Custom:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/Relz_yItqW5RHUsU/images/517733c0-users_functionality_custom_web_screens-89c18bb5f32c29c06539887abef9d188.png?fit=max&auto=format&n=Relz_yItqW5RHUsU&q=85&s=00b2c783d672d358a0bbc6920d2f5c87" width="3600" height="2400" data-path="images/517733c0-users_functionality_custom_web_screens-89c18bb5f32c29c06539887abef9d188.png" />
</Frame>

Below is a list of customizations along with corresponding code snippets

| Property                             | Description                                                                                                                                             | Code                                                          |
| ------------------------------------ | ------------------------------------------------------------------------------------------------------------------------------------------------------- | ------------------------------------------------------------- |
| **title** [report]()                 | Used to set title in the app bar                                                                                                                        | `title="Your Custom Title"`                                   |
| **searchPlaceholderText** [report]() | Used to set search placeholder text                                                                                                                     | `searchPlaceholderText="Your Custom search placeholder text"` |
| **searchIconURL**                    | Used to set search Icon in the search field                                                                                                             | `searchIconURL="Your Custom search icon"`                     |
| **loadingIconURL**                   | Used to set loading Icon                                                                                                                                | `loadingIconURL="your custom loading icon url"`               |
| **closeButtonIconURL** [report]()    | Used to set the close button Icon                                                                                                                       | `closeButtonIconURL="your custom close button icon"`          |
| **hideSearch**                       | Used to toggle visibility for search box                                                                                                                | `hideSearch={true}"`                                          |
| **hideError**                        | Used to hide error on fetching users                                                                                                                    | `hideError={true}`                                            |
| **hideSeparator**                    | Used to hide the divider separating the user items                                                                                                      | `hideSeparator={true}`                                        |
| **disableUsersPresence**             | Used to control visibility of user indicator shown if user is online                                                                                    | `disableUsersPresence={true}`                                 |
| **disableLoadingState** [report]()   | Used to control visibility of loading state                                                                                                             | `disableLoadingState={true}`                                  |
| **emptyStateText** [report]()        | Used to set a custom text response when fetching the users has returned an empty list                                                                   | `emptyStateText="your custom empty state text"`               |
| **errorStateText** [report]()        | Used to set a custom text response when some error occurs on fetching the list of users                                                                 | `errorStateText="your custom error state text"`               |
| **activeUser** [report]()            | Used to set the active user                                                                                                                             | `activeUser={chatUser}`                                       |
| **userPresencePlacement** [report]() | The `userPresencePlacement` property determines the placement of user presence indicators, allowing options for either "right" or "bottom" positioning. | `userPresencePlacement={UserPresencePlacement.right}`         |
| **searchKeyword** [report]()         | The `searchKeyword` property facilitates searching/filtering based on the provided keyword, enhancing the functionality of the component.               | `searchKeyword="Alice"`                                       |

***

### Advance

For advanced-level customization, you can set custom views to the component. This lets you tailor each aspect of the component to fit your exact needs and application aesthetics. You can create and define your views, layouts, and UI elements and then incorporate those into the component.

***

#### ListItemView

With this property, you can assign a custom ListItem to the Users Component.

```
listItemView = { getListItemView };
```

**Example**

Default:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/0Cdnhz6eU6kdn5Ms/images/b25ebf2e-users_listItemView_default_web_screens-817ff24a42eb96280eb523fff7cbc20e.png?fit=max&auto=format&n=0Cdnhz6eU6kdn5Ms&q=85&s=b8d3d5a09ad266342a779ec9dec4a457" width="3600" height="2400" data-path="images/b25ebf2e-users_listItemView_default_web_screens-817ff24a42eb96280eb523fff7cbc20e.png" />
</Frame>

Custom:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/GrDbzzq1LLfv-sgw/images/873ada0d-users_listItemView_custom_web_screens-2440a52eeee3fd2c8e108e2af35fce00.png?fit=max&auto=format&n=GrDbzzq1LLfv-sgw&q=85&s=a1a6a378d31843faba67cf8b67fe001d" width="3600" height="2400" data-path="images/873ada0d-users_listItemView_custom_web_screens-2440a52eeee3fd2c8e108e2af35fce00.png" />
</Frame>

<Tabs>
  <Tab title="TypeScript">
    UsersDemo.tsx

    ```typescript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatUsers } from "@cometchat/chat-uikit-react";

    function UsersDemo() {
      const getListItemView = (user: CometChat.User) => {
        return (
          <div
            style={{
              display: "flex",
              alignItems: "left",
              padding: "10px",
              border: "2px solid #e9baff",
              borderRadius: "20px",
              background: "#ffffff",
            }}
          >
            <cometchat-avatar image={user.getAvatar()} name={user.getName()} />

            <div style={{ display: "flex", paddingLeft: "10px" }}>
              <div
                style={{
                  fontWeight: "bold",
                  color: "#937aff",
                  fontSize: "14px",
                  marginTop: "5px",
                }}
              >
                {user.getName()}
                <div
                  style={{ color: "#cfc4ff", fontSize: "10px", textAlign: "left" }}
                >
                  {user.getStatus()}
                </div>
              </div>
            </div>
          </div>
        );
      };
      return <CometChatUsers listItemView={getListItemView} />;
    }

    export default UsersDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    UsersDemo.jsx

    ```javascript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatUsers } from "@cometchat/chat-uikit-react";

    function UsersDemo() {
      const getListItemView = (user) => {
        return (
          <div
            style={{
              display: "flex",
              alignItems: "left",
              padding: "10px",
              border: "2px solid #e9baff",
              borderRadius: "20px",
              background: "#ffffff",
            }}
          >
            <cometchat-avatar image={user.getAvatar()} name={user.getName()} />

            <div style={{ display: "flex", paddingLeft: "10px" }}>
              <div
                style={{
                  fontWeight: "bold",
                  color: "#937aff",
                  fontSize: "14px",
                  marginTop: "5px",
                }}
              >
                {user.getName()}
                <div
                  style={{ color: "#cfc4ff", fontSize: "10px", textAlign: "left" }}
                >
                  {user.getStatus()}
                </div>
              </div>
            </div>
          </div>
        );
      };

      return <CometChatUsers listItemView={getListItemView} />;
    }

    export default UsersDemo;
    ```
  </Tab>
</Tabs>

***

#### SubtitleView

You can customize the subtitle view for each user item to meet your requirements

```
subtitleView = { getSubtitleView };
```

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/Mh-tK73gC5erLrBQ/images/f57d6d9e-users_subtitleView_custom_web_screens-7aa1af4f579f64849a4eead5977a6c26.png?fit=max&auto=format&n=Mh-tK73gC5erLrBQ&q=85&s=aee4f355c2d50a9da3647a8e4a216ae7" width="3600" height="2400" data-path="images/f57d6d9e-users_subtitleView_custom_web_screens-7aa1af4f579f64849a4eead5977a6c26.png" />
</Frame>

<Tabs>
  <Tab title="TypeScript">
    UsersDemo.tsx

    ```typescript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatUsers } from "@cometchat/chat-uikit-react";

    function UsersDemo() {
      const getSubtitleView = (user: CometChat.User): JSX.Element => {
        function formatTime(timestamp: number) {
          const date = new Date(timestamp * 1000);
          return date.toLocaleString();
        }
        if (user instanceof CometChat.User) {
          return (
            <div
              style={{
                display: "flex",
                alignItems: "left",
                padding: "10px",
                fontSize: "10px",
              }}
            >
              <div style={{ color: "gray" }}>
                Last Active At: {formatTime(user.getLastActiveAt())}
              </div>
            </div>
          );
        } else {
          return <></>;
        }
      };
      return <CometChatUsers subtitleView={getSubtitleView} />;
    }

    export default UsersDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    UsersDemo.jsx

    ```javascript theme={null}
    import { CometChat } from "@cometchat/chat-sdk-javascript";
    import { CometChatUsers } from "@cometchat/chat-uikit-react";

    function UsersDemo() {
      const getSubtitleView = (user) => {
        function formatTime(timestamp) {
          const date = new Date(timestamp * 1000);
          return date.toLocaleString();
        }
        if (user instanceof CometChat.User) {
          return (
            <div
              style={{
                display: "flex",
                alignItems: "left",
                padding: "10px",
                fontSize: "10px",
              }}
            >
              <div style={{ color: "gray" }}>
                Last Active At: {formatTime(user.getLastActiveAt())}
              </div>
            </div>
          );
        } else {
          return <></>;
        }
      };

      return <CometChatUsers subtitleView={getSubtitleView} />;
    }

    export default UsersDemo;
    ```
  </Tab>
</Tabs>

#### LoadingStateView

You can set a custom loader view using `loadingStateView` to match the loading view of your app.

```javascript theme={null}
loadingStateView={getLoadingStateView()}
```

Default:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/L67V-UjCgqzL1qxp/images/72c9976c-users_loadingview_default_web_screens-9518b5dcdcfce21bcd6f618ec10788c3.png?fit=max&auto=format&n=L67V-UjCgqzL1qxp&q=85&s=872460652491c375331eb2142347fa5d" width="3600" height="2400" data-path="images/72c9976c-users_loadingview_default_web_screens-9518b5dcdcfce21bcd6f618ec10788c3.png" />
</Frame>

Custom:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/-ESEkh1kVWNrvtT0/images/66dc0eb6-users_loadingview_custom_web_screens-69f5b50780f182b1e82ed4f2b7e631ae.png?fit=max&auto=format&n=-ESEkh1kVWNrvtT0&q=85&s=f4a3f6d4281b4143e74977a8297eac10" width="3600" height="2400" data-path="images/66dc0eb6-users_loadingview_custom_web_screens-69f5b50780f182b1e82ed4f2b7e631ae.png" />
</Frame>

<Tabs>
  <Tab title="TypeScript">
    UsersDemo.tsx

    ```typescript theme={null}
    import { CometChatUsers, LoaderStyle } from "@cometchat/chat-uikit-react";

    function UsersDemo() {
      const getLoadingStateView = () => {
        const getLoaderStyle = new LoaderStyle({
          iconTint: "#890aff",
          height: "100vh",
          width: "100vw",
        });

        return (
          <cometchat-loader
            iconURL="https://cdn-icons-png.freepik.com/256/6356/6356625.png"
            loaderStyle={JSON.stringify(getLoaderStyle)}
          ></cometchat-loader>
        );
      };

      return <CometChatUsers loadingStateView={getLoadingStateView()} />;
    }

    export default UsersDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    UsersDemo.jsx

    ```javascript theme={null}
    import { CometChatUsers, LoaderStyle } from "@cometchat/chat-uikit-react";

    function UsersDemo() {
      const getLoadingStateView = () => {
        const getLoaderStyle = new LoaderStyle({
          iconTint: "#890aff",
          height: "100vh",
          width: "100vw",
        });

        return (
          <cometchat-loader
            iconURL="https://cdn-icons-png.freepik.com/256/6356/6356625.png"
            loaderStyle={JSON.stringify(getLoaderStyle)}
          ></cometchat-loader>
        );
      };

      return <CometChatUsers loadingStateView={getLoadingStateView()} />;
    }

    export default UsersDemo;
    ```
  </Tab>
</Tabs>

#### EmptyStateView

You can set a custom `EmptyStateView` using `emptyStateView` to match the empty view of your app.

```
emptyStateView={getEmptyStateView()}
```

Default:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/_jsRdrzYcNj1bcHI/images/423fd200-users_emptyview_default_web_screens-d714327a05408bf9f8dfef94ba70a16e.png?fit=max&auto=format&n=_jsRdrzYcNj1bcHI&q=85&s=7072c2741147ee5f96694cb72078d5cc" width="3600" height="2400" data-path="images/423fd200-users_emptyview_default_web_screens-d714327a05408bf9f8dfef94ba70a16e.png" />
</Frame>

Custom:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/bUk-WwSNpBXF92Yc/images/d9c523aa-users_emptyview_custom_web_screens-d0df4badd0d163b2dc33db158a2e491b.png?fit=max&auto=format&n=bUk-WwSNpBXF92Yc&q=85&s=eb736d544b2f22e61813813f899fe6e6" width="3600" height="2400" data-path="images/d9c523aa-users_emptyview_custom_web_screens-d0df4badd0d163b2dc33db158a2e491b.png" />
</Frame>

<Tabs>
  <Tab title="TypeScript">
    UsersDemo.tsx

    ```typescript theme={null}
    import { CometChatUsers } from "@cometchat/chat-uikit-react";

    function UsersDemo() {
      const getEmptyStateView = () => {
        return <div>Your Custom Empty State</div>;
      };

      return <CometChatUsers emptyStateView={getEmptyStateView()} />;
    }

    export default UsersDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    UsersDemo.jsx

    ```javascript theme={null}
    import { CometChatUsers } from "@cometchat/chat-uikit-react";

    function UsersDemo() {
      const getEmptyStateView = () => {
        return <div>Your Custom Empty State</div>;
      };

      return <CometChatUsers emptyStateView={getEmptyStateView()} />;
    }

    export default UsersDemo;
    ```
  </Tab>
</Tabs>

#### ErrorStateView

You can set a custom `ErrorStateView` using `errorStateView` to match the empty view of your app.

```javascript theme={null}
errorStateView={getErrorStateView()}
```

Default:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/RxKy5RgybeX-8GbH/images/1be29124-users_errorview_default_web_screens-66729848c113467ed7d715c5aecd8288.png?fit=max&auto=format&n=RxKy5RgybeX-8GbH&q=85&s=764d221acc87b2af7000a2fbcf012463" width="3600" height="2400" data-path="images/1be29124-users_errorview_default_web_screens-66729848c113467ed7d715c5aecd8288.png" />
</Frame>

Custom:

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/bUk-WwSNpBXF92Yc/images/daa8bc75-users_errorview_custom_web_screens-9e18c9a19c73b7b0d443fc0da231e66e.png?fit=max&auto=format&n=bUk-WwSNpBXF92Yc&q=85&s=4ebf7802334db77545d73eaf7268edaf" width="3600" height="2400" data-path="images/daa8bc75-users_errorview_custom_web_screens-9e18c9a19c73b7b0d443fc0da231e66e.png" />
</Frame>

<Tabs>
  <Tab title="TypeScript">
    UsersDemo.tsx

    ```typescript theme={null}
    import { CometChatUsers } from "@cometchat/chat-uikit-react";

    function UsersDemo() {
      const getErrorStateView = () => {
        return (
          <div style={{ height: "100vh", width: "100vw" }}>
            <img
              src=" custom image "
              alt="error icon"
              style={{
                height: "100px",
                width: "100px",
                marginTop: "250px",
                justifyContent: "center",
              }}
            ></img>
          </div>
        );
      };

      return <CometChatUsers errorStateView={getErrorStateView()} />;
    }

    export default UsersDemo;
    ```
  </Tab>

  <Tab title="javaScript">
    UsersDemo.jsx

    ```javascript theme={null}
    import { CometChatUsers } from "@cometchat/chat-uikit-react";

    function UsersDemo() {
      const getErrorStateView = () => {
        return (
          <div style={{ height: "100vh", width: "100vw" }}>
            <img
              src=" custom image "
              alt="error icon"
              style={{
                height: "100px",
                width: "100px",
                marginTop: "250px",
                justifyContent: "center",
              }}
            ></img>
          </div>
        );
      };

      return <CometChatUsers errorStateView={getErrorStateView()} />;
    }

    export default UsersDemo;
    ```
  </Tab>
</Tabs>

***

#### Menus

You can set the Custom Menu view to add more options to the Users component.

```javascript theme={null}
menus={getMenus()}
```

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/Mh-tK73gC5erLrBQ/images/f7387500-users_menus_web_screens-4265d9c0530f9c360c24ccf98c75533f.png?fit=max&auto=format&n=Mh-tK73gC5erLrBQ&q=85&s=40ad7dc2dd61a7dfaaf8e4d27fd9e28b" width="3600" height="2400" data-path="images/f7387500-users_menus_web_screens-4265d9c0530f9c360c24ccf98c75533f.png" />
</Frame>

<Tabs>
  <Tab title="TypeScript">
    UsersDemo.tsx

    ```typescript theme={null}
    import { CometChatUsers } from "@cometchat/chat-uikit-react";

    function UsersDemo() {
      const getMenus = () => {
        const handleReload = () => {
          window.location.reload();
        };
        const getButtonStyle = () => {
          return {
            height: "20px",
            width: "20px",
            border: "none",
            borderRadius: "0",
            background: "transparent",
            buttonIconTint: "#7E57C2",
          };
        };
        return (
          <div style={{ marginRight: "20px" }}>
            <cometchat-button
              iconURL="icon"
              buttonStyle={JSON.stringify(getButtonStyle())}
              onClick={handleReload}
            >
              {" "}
            </cometchat-button>
          </div>
        );
      };

      return <CometChatUsers menus={getMenus()} />;
    }

    export default UsersDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    UsersDemo.jsx

    ```javascript theme={null}
    import { CometChatUsers } from "@cometchat/chat-uikit-react";

    function UsersDemo() {
      const getMenus = () => {
        const handleReload = () => {
          window.location.reload();
        };
        const getButtonStyle = () => {
          return {
            height: "20px",
            width: "20px",
            border: "none",
            borderRadius: "0",
            background: "transparent",
            buttonIconTint: "#7E57C2",
          };
        };
        return (
          <div style={{ marginRight: "20px" }}>
            <cometchat-button
              iconURL="icon"
              buttonStyle={JSON.stringify(getButtonStyle())}
              onClick={handleReload}
            >
              {" "}
            </cometchat-button>
          </div>
        );
      };

      return <CometChatUsers menus={getMenus()} />;
    }

    export default UsersDemo;
    ```
  </Tab>
</Tabs>

***

#### Options

You can set the Custom options to the Users component.

<Frame>
  <img src="https://mintcdn.com/cometchat-22654f5b/THlknidvlbNx5AzI/images/a923d4a0-users_options_web_screens-bb164b0745ab580bd787ef4a1a9c1b95.png?fit=max&auto=format&n=THlknidvlbNx5AzI&q=85&s=e0ac89b709feca7d14f38c7658b23423" width="3600" height="2400" data-path="images/a923d4a0-users_options_web_screens-bb164b0745ab580bd787ef4a1a9c1b95.png" />
</Frame>

<Tabs>
  <Tab title="TypeScript">
    UsersDemo.tsx

    ```typescript theme={null}
    import { CometChatUsers, CometChatOption } from "@cometchat/chat-uikit-react";

    function UsersDemo() {
      return (
        <CometChatUsers
          options={(user: any) => {
            const customOptions = [
              new CometChatOption({
                id: "1",
                title: "Title",
                iconURL: "icon",
                backgroundColor: "transparent",
                onClick: () => {
                  console.log("Custom option clicked for user:", user);
                },
                iconTint: "#890aff",
                titleColor: "blue",
              }),
            ];
            return customOptions;
          }}
        />
      );
    }

    export default UsersDemo;
    ```
  </Tab>

  <Tab title="JavaScript">
    UsersDemo.jsx

    ```javascript theme={null}
    import { CometChatUsers, CometChatOption } from "@cometchat/chat-uikit-react";

    function UsersDemo() {
      return (
        <CometChatUsers
          options={(user) => {
            const customOptions = [
              new CometChatOption({
                id: "1",
                title: "Title",
                iconURL: "icon",
                backgroundColor: "transparent",
                onClick: () => {
                  console.log("Custom option clicked for user:", user);
                },
                iconTint: "#890aff",
                titleColor: "blue",
              }),
            ];
            return customOptions;
          }}
        />
      );
    }

    export default UsersDemo;
    ```
  </Tab>
</Tabs>
